'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _unirest = require('unirest');

var _unirest2 = _interopRequireDefault(_unirest);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _analytics = require('./analytics');

var _analytics2 = _interopRequireDefault(_analytics);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// import User from './user';
// import Event from './event';
// import Company from './company';
// import Contact from './contact';
// import Visitor from './visitor';
// import Counts from './counts';
// import Admin from './admin';
// import Tag from './tag';
// import Segment from './segment';
// import Message from './message';
// import Conversation from './conversation';
// import Note from './note';

var Client = function () {
  function Client(token) {
    _classCallCheck(this, Client);

    // constructor(...args) {
    // if (args.length === 2) {
    //   this.usernamePart = args[0];
    //   this.passwordPart = args[1];
    // } else if (args.length === 1) {
    //   if (args[0].token) {
    //     this.usernamePart = args[0].token;
    //     this.passwordPart = '';
    //   } else {
    //     this.usernamePart = args[0].appId;
    //     this.passwordPart = args[0].appApiKey;
    //   }
    // }
    // if (!this.usernamePart || this.passwordPart === undefined) {
    //   throw new Error('Could not construct a client with those parameters');
    // }
    this.token = token;
    if (!this.token || this.token === undefined) {
      throw new Error('Could not construct a client with those parameters');
    }

    this.analytics = new _analytics2.default(this);

    // this.users = new User(this);
    // this.events = new Event(this);
    // this.companies = new Company(this);
    // this.contacts = new Contact(this);
    // this.leads = new Contact(this);
    // this.visitors = new Visitor(this);
    // this.counts = new Counts(this);
    // this.admins = new Admin(this);
    // this.tags = new Tag(this);
    // this.segments = new Segment(this);
    // this.messages = new Message(this);
    // this.conversations = new Conversation(this);
    // this.notes = new Note(this);
    this.promises = false;
  }

  _createClass(Client, [{
    key: 'usePromises',
    value: function usePromises() {
      this.promises = true;
      return this;
    }
  }, {
    key: 'promiseProxy',
    value: function promiseProxy(f, req) {
      var _this = this;

      if (this.promises || !f) {
        var _ret = function () {
          var callbackHandler = _this.callback;
          return {
            v: new _bluebird2.default(function (resolve, reject) {
              var resolver = function resolver(err, data) {
                if (err) {
                  reject(new Error(JSON.stringify(err)));
                } else {
                  resolve(data);
                }
              };
              req.end(function (r) {
                return callbackHandler(resolver, r);
              });
            })
          };
        }();

        if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
      } else {
        req.end(function (r) {
          return _this.callback(f, r);
        });
      }
    }
  }, {
    key: 'put',
    value: function put(endpoint, data, f) {
      return this.promiseProxy(f, _unirest2.default.put('https://api2.frontapp.com' + endpoint)
      //.auth(this.usernamePart, this.passwordPart)
      .type('json').send(data).header('Authorization', 'Bearer ' + this.token).header('Accept', 'application/json').header('User-Agent', 'frontapp/1.0.0'));
    }
  }, {
    key: 'post',
    value: function post(endpoint, data, f) {
      return this.promiseProxy(f, _unirest2.default.post('https://api2.frontapp.com' + endpoint)
      //.auth(this.usernamePart, this.passwordPart)
      .type('json').send(data).header('Accept', 'application/json').header('User-Agent', 'frontapp/1.0.0'));
    }
  }, {
    key: 'get',
    value: function get(endpoint, data, f) {
      return this.promiseProxy(f, _unirest2.default.get('https://api2.frontapp.com' + endpoint)
      //.auth(this.usernamePart, this.passwordPart)
      .type('json').query(data).header('Authorization', 'Bearer ' + this.token).header('Accept', 'application/json').header('User-Agent', 'frontapp/1.0.0'));
    }
  }, {
    key: 'nextPage',
    value: function nextPage(paginationObject, f) {
      return this.promiseProxy(f, _unirest2.default.get(paginationObject.next)
      //.auth(this.usernamePart, this.passwordPart)
      .type('json').header('Authorization', 'Bearer ' + this.token).header('Accept', 'application/json').header('User-Agent', 'frontapp/1.0.0'));
    }
  }, {
    key: 'delete',
    value: function _delete(endpoint, data, f) {
      return this.promiseProxy(f, _unirest2.default.delete('https://api2.frontapp.com' + endpoint)
      //.auth(this.usernamePart, this.passwordPart)
      .type('json').query(data).header('Authorization', 'Bearer ' + this.token).header('Accept', 'application/json').header('User-Agent', 'frontapp/1.0.0'));
    }
  }, {
    key: 'callback',
    value: function callback(f, data) {
      if (!f) {
        return;
      }
      if (f.length >= 2) {
        var hasErrors = data.error || data.body && data.body.type === 'error.list';
        if (hasErrors) {
          f(data, null);
        } else {
          f(null, data);
        }
      } else {
        f(data);
      }
    }
  }]);

  return Client;
}();

exports.default = Client;